package com.xkrs.controller;

import com.dahuatech.icc.event.model.v202011.EventSubscribeRequest;
import com.dahuatech.icc.event.model.v202011.EventSubscribeResponse;
import com.dahuatech.icc.oauth.http.DefaultClient;
import com.dahuatech.icc.oauth.http.IClient;
import com.xkrs.service.FireEventService;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * @Author: XinYi Song
 * @Date: 2022/2/11 9:03
 */
@RestController
public class FireEventController {

    @Resource
    private FireEventService fireEventService;

    /**
     * 订阅火情事件
     */
    @GetMapping("/subscribeFireEvent")
    public void subscribeFireEvent() {
        try {
            //118.24.27.47:6820
            String host = "111.53.13.180:4433";
            String username = "system";
            String password = "Admin@123";
            String clientId = "xkrszhcx";
            String clientSecret = "eac429df-950a-4cba-aa50-76e47b0a74d8";
            System.out.println("----开始执行----{}------事件订阅");
            IClient iClient = new DefaultClient(host, username, password, clientId, clientSecret);
            EventSubscribeRequest subscribeRequest = new EventSubscribeRequest();
            // 接收事件地址
            String receiveUrl = "http://118.24.27.47:6820/receiveFireEvent";
            String mqinfo = "{\"param\":{\"monitors\":[{\"monitor\":\"" + receiveUrl + "\",\"monitorType\":\"url\",\"events\":[{\"category\":\"business\",\"subscribeAll\":1,\"domainSubscribe\":2,\"authorities\":[{}]},{\"category\":\"alarm\",\"subscribeAll\":1,\"domainSubscribe\":2,\"authorities\":[{}]},{\"category\":\"state\",\"subscribeAll\":1,\"domainSubscribe\":2,\"authorities\":[{}]}]}],\"subsystem\":{\"subsystemType\":0,\"name\":\"118.24.27.47_6820\",\"magic\":\"118.24.27.47_6820\"}}}";
            subscribeRequest.body(mqinfo);
            EventSubscribeResponse subscribeResponse = iClient.doAction(subscribeRequest, subscribeRequest.getResponseClass());
            System.out.println("----结束执行----{}------事件订阅" + subscribeResponse.toString());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 接收火情事件
     */
    @PostMapping("/receiveFireEvent")
    public void receiveFireEvent(@RequestBody Object fireEvent) {
        try {
            System.out.println("----接收火情事件----{}------" + fireEvent.toString());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 查询火情事件
     */
    @GetMapping("/selectFireEvent")
    public String selectFireEvent() {
        return fireEventService.selectFireEventList();
    }

}
